scala.tools.nsc.backend.icode.Linearizers

# ReversePostOrderLinearizer

#### class ReversePostOrderLinearizer extends ICodes.Linearizer

Linearize code in reverse post order. In fact, it does a post order traversal, prepending visited nodes to the list. This way, it is constructed already in reverse post order.

Source
  Linearizers.scala

Linear Supertypes
ICodes.Linearizer, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ReversePostOrderLinearizer
2. Linearizer
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ReversePostOrderLinearizer()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to any2stringadd[ICodes.ReversePostOrderLinearizer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodes.ReversePostOrderLinearizer, B)

   Implicit information
     This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to ArrowAssoc[ICodes.ReversePostOrderLinearizer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def add(b: ICodes.BasicBlock): Unit

   Prepend b to the list, if not already scheduled.

   Prepend b to the list, if not already scheduled.

   returns

     Returns true if the block was added.

7. #### val added: BitSet

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### var blocks: List[ICodes.BasicBlock]

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### def ensuring(cond: (ICodes.ReversePostOrderLinearizer) ⇒ Boolean, msg: ⇒ Any): ICodes.ReversePostOrderLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to Ensuring[ICodes.ReversePostOrderLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (ICodes.ReversePostOrderLinearizer) ⇒ Boolean): ICodes.ReversePostOrderLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to Ensuring[ICodes.ReversePostOrderLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodes.ReversePostOrderLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to Ensuring[ICodes.ReversePostOrderLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): ICodes.ReversePostOrderLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to Ensuring[ICodes.ReversePostOrderLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to StringFormat[ICodes.ReversePostOrderLinearizer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

22. #### def linearize(m: ICodes.IMethod): List[ICodes.BasicBlock]

    Definition Classes
      ReversePostOrderLinearizer → Linearizer

23. #### def linearizeAt(m: ICodes.IMethod, start: ICodes.BasicBlock): List[ICodes.BasicBlock]

    Definition Classes
      ReversePostOrderLinearizer → Linearizer

24. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

25. #### final def notify(): Unit

    Definition Classes
      AnyRef

26. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

27. #### def rpo(b: ICodes.BasicBlock): Unit

28. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

29. #### def toString(): String

    Definition Classes
      AnyRef → Any

30. #### val visited: HashSet[ICodes.BasicBlock]

31. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

32. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### def →[B](y: B): (ICodes.ReversePostOrderLinearizer, B)

    Implicit information
      This member is added by an implicit conversion from ICodes.ReversePostOrderLinearizer to ArrowAssoc[ICodes.ReversePostOrderLinearizer] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from ICodes.Linearizer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodes.ReversePostOrderLinearizer to any2stringadd[ICodes.ReversePostOrderLinearizer]

### Inherited by implicit conversion StringFormat from ICodes.ReversePostOrderLinearizer to StringFormat[ICodes.ReversePostOrderLinearizer]

### Inherited by implicit conversion Ensuring from ICodes.ReversePostOrderLinearizer to Ensuring[ICodes.ReversePostOrderLinearizer]

### Inherited by implicit conversion ArrowAssoc from ICodes.ReversePostOrderLinearizer to ArrowAssoc[ICodes.ReversePostOrderLinearizer]

### Ungrouped